global function OnWeaponPrimaryAttack_shifter
global function MpAbilityShifterWeapon_Init
global function MpAbilityShifterWeapon_OnWeaponTossPrep
global function AbilityShifter_ApplyInProgressStimIfNeeded

const SHIFTER_WARMUP_TIME = 0.0
const SHIFTER_WARMUP_TIME_FAST = 0.0

global const SHIFTER_WARMUP_TIME_WRAITH = 1.25

const float PMMOD_ENDLESS_STRENGTH = 0.8

const WRAITH_SEVERITY_SLOWMOVE = 0.25
const SHIFTER_SLOWMOVE_TIME_WRAITH = 1.25
global const WRAITH_SPEED_BOOST_SEVERITY = 0.25

#if SERVER
// Portal stuff
const float PORTAL_TICKRATE = 0.1
const float PORTAL_DURATION = 30 // should be fx_tickrate * 20, could be tickrate * 22 in actual
const float PORTAL_MAX_DISTANCE = 2500
const float PORTAL_CANCEL_PERCENTAGE = 0.95
//const float PORTAL_MIN_DISTANCE = 150 // using PORTAL_CANCEL_PERCENTAGE
const float PORTAL_TRAVEL_LENGTH_MAX = 2.0 // shouldn't have a limit since we have checked player speed before adding to vector array, but it'll be too slow because of the tickrate limit
//const float PORTAL_TRAVEL_LENGTH_MIN = 0.4 // min phase duation, basically shouldn't have a limit
//const float PORTAL_TRAVEL_TICKRATE = PORTAL_TICKRATE / 5 // travel tickrate, let's ingore this shit
const float PORTAL_NODES_MAX = PORTAL_TRAVEL_LENGTH_MAX / PORTAL_TICKRATE // use for checking overloaded nodes
const float PORTAL_DEPLOY_TIME = 1.2 // defensive fix
const float PORTAL_FX_TICKRATE = 1.5

const vector ROOFCHECK_HEIGHT = < 0,0,100 > // added pilot's height( 60 ), so actually it's 40 height check
const float FIX_AMOUNT = 20

const bool shouldDoWarpEffect = false // warp is so annoying! can turn it off if need( before we able to remove extra nodes )

struct PortalData
{
	array<vector> progPoses
	array<vector> progAngs
}

struct PortalStruct
{
	vector goalPos
	vector goalAng
	float travelTime
	string ownerUID
	bool canPortalOwner
	PortalData savedVecs
}

table<string, bool> playerPlacingPortal = {}
table<entity, PortalStruct> portalGoalTable = {}
array<string> inPortalCooldownPlayers = []

#endif
const string PHASEEXIT_IMPACT_TABLE_PROJECTILE	= "default"
const string PHASEEXIT_IMPACT_TABLE_TRACE		= "superSpectre_groundSlam_impact"

int ammoreduce

struct
{
	int phaseExitExplodeImpactTable
} file;

void function MpAbilityShifterWeapon_Init()
{
	// "exp_rocket_archer"
	// "exp_xlarge"
	// "exp_arc_ball"
	file.phaseExitExplodeImpactTable = PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_PROJECTILE )
	PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_TRACE )
}

void function MpAbilityShifterWeapon_OnWeaponTossPrep( entity weapon, WeaponTossPrepParams prepParams )
{
	entity weaponOwner = weapon.GetWeaponOwner()
	if( weapon.HasMod( "wraith_phase" ) )
	{
		int phaseResult = PhaseShift( weaponOwner, SHIFTER_WARMUP_TIME_WRAITH, weapon.GetWeaponSettingFloat( eWeaponVar.fire_duration ) )
		if( phaseResult )
		{
			StatusEffect_AddTimed( weapon.GetWeaponOwner(), eStatusEffect.move_slow, WRAITH_SEVERITY_SLOWMOVE, SHIFTER_SLOWMOVE_TIME_WRAITH, 0 )
			ammoreduce = weapon.GetWeaponSettingInt( eWeaponVar.ammo_min_to_fire )
		}
		else
			ammoreduce = 0
	}
	int pmLevel = GetPVEAbilityLevel( weapon )
	if ( (pmLevel >= 2) && IsValid( weaponOwner ) && weaponOwner.IsPhaseShifted() )
		weapon.SetScriptTime0( Time() )
	else
		weapon.SetScriptTime0( 0.0 )
}

int function GetPVEAbilityLevel( entity weapon )
{
	if ( weapon.HasMod( "pm2" ) )
		return 2
	if ( weapon.HasMod( "pm1" ) )
		return 1
	if ( weapon.HasMod( "pm0" ) )
		return 0

	return -1
}

var function OnWeaponPrimaryAttack_shifter( entity weapon, WeaponPrimaryAttackParams attackParams )
{
	entity player = weapon.GetWeaponOwner()
	if( !IsValid( player ) )
		return

	float warmupTime = SHIFTER_WARMUP_TIME
	if ( weapon.HasMod( "short_shift" ) )
	{
		warmupTime = SHIFTER_WARMUP_TIME_FAST
	}
	if ( weapon.HasMod( "wraith_phase" ) )
	{
		warmupTime = SHIFTER_WARMUP_TIME_WRAITH
	}
if( weapon.HasMod( "wraith_portal" ) )
	{
		#if SERVER
		int ammoMax = weapon.GetWeaponPrimaryClipCountMax()
		string playerUID = player.GetUID()

		if (weapon.GetWeaponPrimaryClipCount() == ammoMax ) //first charge
		{ 
			thread PortalStart( player, weapon )
			return weapon.GetWeaponSettingInt( eWeaponVar.ammo_min_to_fire )
		}
		else if(weapon.GetWeaponPrimaryClipCount() == ammoMax / 2 && playerUID in playerPlacingPortal ) //second charge
		{
			if( playerPlacingPortal[ playerUID ] )
			{
				player.Signal( "PlacedPortal" )
				return weapon.GetWeaponSettingInt( eWeaponVar.ammo_min_to_fire )
			}
			else
			{
				SendHudMessage( player, "Portal start Not Detected\nRecharged", -1, 0.65, 255, 255, 100, 1, 0, 4, 0 )
				weapon.SetWeaponPrimaryClipCount( ammoMax )
			}
		}
		else if( !(playerUID in playerPlacingPortal) )
		{
			SendHudMessage( player, "Portal Failed, Recharged", -1,0.65,255,255,100,1,0,4,0 )
			weapon.SetWeaponPrimaryClipCount( ammoMax )
		}
		/*
		else
		{
			SendHudMessage( player, "Need Full Recharge to place portal", -1,0.65,255,255,100,1,0,4,0 )
		}
		*/
		#endif
		return 0
	}

	entity weaponOwner = weapon.GetWeaponOwner()

	int pmLevel = GetPVEAbilityLevel( weapon )
	if ( weaponOwner.IsPlayer() && (pmLevel >= 0) )
	{
		if ( weaponOwner.IsPhaseShifted() )
		{
			float scriptTime = weapon.GetScriptTime0()
			if ( (pmLevel >= 2) && (scriptTime != 0.0) )
			{
				float chargeMaxTime = weapon.GetWeaponSettingFloat( eWeaponVar.custom_float_0 )
				float chargeTime = (Time() - scriptTime)
				if ( chargeTime >= chargeMaxTime )
				{
					DoPhaseExitExplosion( weaponOwner, weapon )
					StatusEffect_AddTimed( weaponOwner, eStatusEffect.move_slow, 1.0, 1.5, 1.5 )	// "stick" a bit more than usual on exit
				}
			}

			CancelPhaseShift( weaponOwner );
			EndlessStimEnd( weaponOwner )

			if ( pmLevel >= 0 )
				StatusEffect_AddTimed( weaponOwner, eStatusEffect.move_slow, 0.75, 0.75, 0.75 )	// "stick" a bit on exit

			return weapon.GetWeaponSettingInt( eWeaponVar.ammo_min_to_fire )
		}
		else
		{
			PhaseShift( weaponOwner, 0, 99999 );
			if ( pmLevel >= 1 )
				EndlessStimBegin( weaponOwner, PMMOD_ENDLESS_STRENGTH )
			return 0
		}
	}
	else
	{
		if( weapon.HasMod( "wraith_phase" ) )
		{
			return ammoreduce
		}
		else
		{
			int phaseResult = PhaseShift( weaponOwner, warmupTime, weapon.GetWeaponSettingFloat( eWeaponVar.fire_duration ) )
			if ( phaseResult )
			{
				PlayerUsedOffhand( weaponOwner, weapon )
				#if BATTLECHATTER_ENABLED && SERVER
					TryPlayWeaponBattleChatterLine( weaponOwner, weapon )
				#endif

				return weapon.GetWeaponSettingInt( eWeaponVar.ammo_min_to_fire )
			}
		}
	}

	return 0
}

void function ApplyInProgressStimIfNeededThread( entity player )
{
	wait 0.5  // timed to kick in when the notify appears on player's screen

	if ( !IsAlive( player ) )
		return
	if ( !player.IsPhaseShifted() )
		return

	EndlessStimBegin( player, PMMOD_ENDLESS_STRENGTH )
}

void function AbilityShifter_ApplyInProgressStimIfNeeded( entity player )
{
	thread ApplyInProgressStimIfNeededThread( player )
}

void function DoPhaseExitExplosion( entity player, entity phaseWeapon )
{
#if CLIENT
	if ( !phaseWeapon.ShouldPredictProjectiles() )
		return
#endif //

	player.PhaseShiftCancel()

	vector origin = player.GetWorldSpaceCenter() + player.GetForwardVector() * 16.0

	//DebugDrawLine( player.GetWorldSpaceCenter(), origin, 255, 0, 0, true, 5.0 )

	int damageType = (DF_RAGDOLL | DF_EXPLOSION | DF_ELECTRICAL)
	entity nade = phaseWeapon.FireWeaponGrenade( origin, <0,0,1>, <0,0,0>, 0.01, damageType, damageType, true, true, true )
	if ( !nade )
		return

	player.PhaseShiftBegin( 0, 1.0 )

	nade.SetImpactEffectTable( file.phaseExitExplodeImpactTable )
	nade.GrenadeExplode( <0,0,0> )

#if SERVER
	PlayImpactFXTable( player.GetOrigin(), player, PHASEEXIT_IMPACT_TABLE_TRACE, SF_ENVEXPLOSION_INCLUDE_ENTITIES )
#endif //
}

// Portal Stuff
#if SERVER
void function PortalStart( entity player, entity weapon )
{
	if( !IsAlive( player ) )
		return
	if( !IsValid( weapon ) )
		return
	// why signals not work?
	//player.EndSignal( "OnDeath" )
	//player.EndSignal( "OnDestroy" )
	//player.EndSignal( "PlacedPortal" )
	//weapon.EndSignal( "OnDestroy" )
	if( IsValid( weapon ) )
	{
		weapon.AddMod( "no_regen" )
		//weapon.SetWeaponPrimaryClipCount( weapon.GetWeaponPrimaryClipCountMax() / 2 )
	}

	SendHudMessage( player,"Placing Portal", -1, 0.65, 255, 255, 100, 1, 0, 3, 0 )

	wait PORTAL_DEPLOY_TIME // defensive fix
	if( !IsAlive( player ) ) // if player died before actually starting placing portal, just return
		return
	// should set up down here
	
	string playerUID = player.GetUID()
	playerPlacingPortal[ playerUID ] <- true

	int statusEffect = StatusEffect_AddEndless( player, eStatusEffect.speed_boost, WRAITH_SPEED_BOOST_SEVERITY )
	entity stimFX = StartParticleEffectOnEntity_ReturnEntity( player, PILOT_STIM_HLD_FX, FX_PATTACH_POINT_FOLLOW, player.LookupAttachment( "CHESTFOCUS" ) )
	stimFX.SetOwner( player )
	stimFX.kv.VisibilityFlags = (ENTITY_VISIBLE_TO_FRIENDLY | ENTITY_VISIBLE_TO_ENEMY)

	EmitSoundOnEntityOnlyToPlayer( player, player, SHIFTER_START_SOUND_1P )
	EmitSoundOnEntity( player, SHIFTER_START_SOUND_3P )
	EmitSoundOnEntityOnlyToPlayer( player, player, "Pilot_PhaseShift_Loop_1P" )
	EmitSoundOnEntity( player, "Pilot_PhaseShift_Loop_3P" )
	PlayFX( $"P_phase_shift_main", player.GetOrigin() )

	vector startPos = player.GetOrigin()
	vector startAng = player.EyeAngles()
	startAng.x = 0
	array<vector> progressPoses
	array<vector> progressAngs
	float travelTime = 0
	if( player.IsOnGround() )
		startPos += < 0,0,FIX_AMOUNT >
	else if( TraceLine( player.GetOrigin(), player.GetOrigin() + ROOFCHECK_HEIGHT, [ player ], TRACE_MASK_SHOT, TRACE_COLLISION_GROUP_NONE ).hitEnt != null )
		startPos -= < 0,0,FIX_AMOUNT >
	vector lastTickPos = player.GetOrigin()
	float portalLeft = PORTAL_MAX_DISTANCE

	/* // shouldn't be at the bottom of the function, or it will be pretty messed up
	OnThreadEnd(
		function() : ( player, playerUID, weapon, startPos, startAng, progressVecs, progressAngs, travelTime, statusEffect, stimFX )
		{
			thread DelayedClearTable( playerUID )
			if( IsValid( player ) )
			{
				StatusEffect_Stop( player, statusEffect )
				StopSoundOnEntity( player, "Pilot_PhaseShift_Loop_1P" )
				StopSoundOnEntity( player, "Pilot_PhaseShift_Loop_3P" )
				PortalEnd( player, weapon, startPos, startAng, progressVecs, progressAngs, travelTime )
			}
			if( IsValid( stimFX ) )
				EffectStop( stimFX )
		}
	)
	*/
	
	while( true )
	{
		wait PORTAL_TICKRATE
		if( IsAlive( player ) )
		{
			//float distance = fabs( Distance2D( startPos, player.GetOrigin() ) )
			//if( distance >= PORTAL_MAX_DISTANCE )
				//break

			if( portalLeft <= 0 )
				break
			if( !IsValid( weapon ) )
				break
			if( player.GetActiveWeapon().HasMod( "wraith_portal" ) )
				break
			/*
			SendHudMessage( player,"传送门距离剩余：" + string( ( 1 - distance / PORTAL_MAX_DISTANCE ) * 100 ) + "%", -1, 0.65, 255, 255, 100, 1, 0, 0.2, 0 )
			if( player.GetVelocity() != < 0,0,0 > )
				travelTime += PORTAL_TICKRATE
			if( travelTime >= PORTAL_TRAVEL_LENGTH_MAX )
				travelTime = PORTAL_TRAVEL_LENGTH_MAX
			*/
			if( player.GetVelocity() != < 0,0,0 > )
			{
				progressPoses.append( player.GetOrigin() )
				progressAngs.append( < 0, player.EyeAngles().y, player.EyeAngles().z > )
				portalLeft -= fabs( Distance2D( lastTickPos, player.GetOrigin() ) )
				travelTime += PORTAL_TICKRATE
				lastTickPos = player.GetOrigin()
			}
			float portalPercentage = portalLeft / PORTAL_MAX_DISTANCE * 100
			if( portalPercentage <= 0 )
				portalPercentage = 0
			SendHudMessage( player,"Portal Left: " + string( portalPercentage ) + "%", -1, 0.65, 255, 255, 100, 1, 0, 0.2, 0 )
		}
		else
			break
	}

	thread DelayedClearTable( playerUID )
	if( IsValid( player ) )
	{
		StatusEffect_Stop( player, statusEffect )
		StopSoundOnEntity( player, "Pilot_PhaseShift_Loop_1P" )
		StopSoundOnEntity( player, "Pilot_PhaseShift_Loop_3P" )
		PortalEnd( player, weapon, startPos, startAng, progressPoses, progressAngs, travelTime, portalLeft )
	}
	if( IsValid( stimFX ) )
		EffectStop( stimFX )
}

void function PortalEnd( entity player, entity weapon, vector startPos, vector startAng, array<vector> progressPoses, array<vector> progressAngs, float travelTime, float portalLeft )
{
	if( IsValid( weapon ) )
	{
		weapon.RemoveMod( "no_regen" )
		thread DelayedDiscardAmmo( weapon )
	}
	vector endPos = player.GetOrigin()
	vector endAng = player.EyeAngles()
	endAng.x = 0
	if( player.IsOnGround() )
		endPos += < 0,0,FIX_AMOUNT >
	else if( TraceLine( player.GetOrigin(), player.GetOrigin() + ROOFCHECK_HEIGHT, [ player ], TRACE_MASK_SHOT, TRACE_COLLISION_GROUP_NONE ).hitEnt != null )
		endPos -= < 0,0,FIX_AMOUNT >
	
	EmitSoundOnEntity( player, SHIFTER_END_SOUND_3P )
	PlayFX( $"P_phase_shift_main", player.GetOrigin() )

	/* //using PORTAL_CANCEL_PERCENTAGE
	if( fabs( Distance2D( startPos, endPos ) ) <= PORTAL_MIN_DISTANCE )
	{
		SendHudMessage( player,"传送门放置已取消", -1, 0.65, 255, 255, 100, 1, 0, 4, 0 )
		thread DelayedRechargeWeapon( weapon )
		return
	}
	*/
	if( portalLeft / PORTAL_MAX_DISTANCE >= PORTAL_CANCEL_PERCENTAGE )
	{
		SendHudMessage( player,"Portal Canceled", -1, 0.65, 255, 255, 100, 1, 0, 4, 0 )
		thread DelayedRechargeWeapon( weapon )
		return
	}

	// idk how to use it
	//DebugDrawCircle( startPos, startAng, 60, 128, 255, 128, false, PORTAL_DURATION, 32 )
	//DebugDrawCircle( endPos, endAng, 60, 128, 255, 128, false, PORTAL_DURATION, 32 )

	entity startTrig = CreateTriggerRadiusMultiple( startPos, 64, [], TRIG_FLAG_PLAYERONLY | TRIG_FLAG_NO_PHASE_SHIFT, 48, 48 )
	entity endTrig = CreateTriggerRadiusMultiple( endPos, 64, [], TRIG_FLAG_PLAYERONLY | TRIG_FLAG_NO_PHASE_SHIFT, 48, 48 )
	
	//print( "[PORTAL] Total travel time is " + string( travelTime ) )

	// let's remove overloaded nodes
	if( progressPoses.len() >= PORTAL_NODES_MAX )
	{
		array<vector> tempVectors
		float overTime = travelTime - PORTAL_TRAVEL_LENGTH_MAX
		float overTicks = overTime / PORTAL_TICKRATE
		int segment = int( progressPoses.len() / PORTAL_NODES_MAX )
		for( int i = 0; i < overTicks; i++ )
		{
			if( progressPoses.len() <= segment * i )
				break
			tempVectors.append( progressPoses[ segment * i ] )
		}
		travelTime = PORTAL_TRAVEL_LENGTH_MAX
		progressPoses = tempVectors
		//print( "[PORTAL] Nodes count reset to " + string( progressPoses.len() ) + ", and travel time has been set to " + string( travelTime ) )
	}

	// reverse start & end origin and angle
	PortalStruct startStruct
	startStruct.goalPos = endPos
	startStruct.goalAng = endAng
	startStruct.travelTime = travelTime
	startStruct.ownerUID = player.GetUID()
	startStruct.canPortalOwner = false
	startStruct.savedVecs.progPoses = progressPoses // reverse while phasing back, see below
	startStruct.savedVecs.progAngs = progressAngs
	portalGoalTable[ startTrig ] <- startStruct
	SetTeam( startTrig, TEAM_IMC ) // to check if it's start or end, imc = startTrig, mlt = endTrig

	PortalStruct endStruct
	endStruct.goalPos = startPos
	endStruct.goalAng = startAng
	endStruct.travelTime = travelTime
	endStruct.ownerUID = player.GetUID()
	endStruct.canPortalOwner = false
	endStruct.savedVecs.progPoses = progressPoses
	endStruct.savedVecs.progAngs = progressAngs
	portalGoalTable[ endTrig ] <- endStruct
	SetTeam( endTrig, TEAM_MILITIA )

	/* // no need to try this, seriously
	startTrig.SetAngles( startAng )
	startTrig.kv.fadedist = travelTime // to save travel duration
	SetTeam( startTrig, TEAM_IMC ) // to check if it's start or end, imc = startTrig, mlt = endTrig

	
	endTrig.SetAngles( endAng )
	endTrig.kv.fadedist = travelTime
	SetTeam( endTrig, TEAM_MILITIA )

	startTrig.kv.rendercolor =  string(endTrig.x) + " " + string(endTrig.y) + " " + string(endTrig.y)//pretty silly, save fliped pos by this
	endTrig.kv.rendercolor = string(startPos.x) + " " + string(startPos.y) + " " + string(startPos.y)
	*/

	if( !( IsValid( startTrig ) || IsValid( endTrig ) || IsValid( player ) ) )
		return

	SendHudMessage( player,"Portal Placed!", -1, 0.65, 255, 255, 100, 1, 0, 4, 0 )
	EmitSoundAtPosition( TEAM_UNASSIGNED, startTrig.GetOrigin(), SHIFTER_END_SOUND_3P_TITAN )
	EmitSoundAtPosition( TEAM_UNASSIGNED, endTrig.GetOrigin(), SHIFTER_END_SOUND_3P_TITAN )
	//print( "[PORTAL] " + player.GetPlayerName() + " placed portal!" )

	AddCallback_ScriptTriggerEnter( startTrig, OnPortalTiggerEnter )
	AddCallback_ScriptTriggerEnter( endTrig, OnPortalTiggerEnter )

	ScriptTriggerSetEnabled( startTrig, true )
	ScriptTriggerSetEnabled( endTrig, true )

	thread PortalLifetimeManagement( startTrig, endTrig )
}

void function PortalLifetimeManagement( entity startTrig, entity endTrig )
{
	float startTime = Time()
	while( Time() < startTime + PORTAL_DURATION )
	{
		wait PORTAL_FX_TICKRATE
		if( IsValid( startTrig ) )
		{
			EmitSoundAtPosition( TEAM_UNASSIGNED, startTrig.GetOrigin(), "Pilot_PhaseShift_WarningToEnd_3P" )
			PlayFX( $"P_phase_shift_main", startTrig.GetOrigin() )
		}
		if( IsValid( endTrig ) )
		{
			EmitSoundAtPosition( TEAM_UNASSIGNED, endTrig.GetOrigin(), "Pilot_PhaseShift_WarningToEnd_3P" )
			PlayFX( $"P_phase_shift_main", endTrig.GetOrigin() )
		}
		if( !IsValid( startTrig ) && !IsValid( endTrig ) )
			return
	}
	wait PORTAL_FX_TICKRATE
	if( IsValid( startTrig ) )
	{
		EmitSoundAtPosition( TEAM_UNASSIGNED, startTrig.GetOrigin(), SHIFTER_END_SOUND_3P )
		startTrig.Destroy()
	}
	if( IsValid( endTrig ) )
	{
		EmitSoundAtPosition( TEAM_UNASSIGNED, endTrig.GetOrigin(), SHIFTER_END_SOUND_3P )
		endTrig.Destroy()
	}
}

void function OnPortalTiggerEnter( entity trigger, entity player )
{
	if( !IsValid( player ) )
		return
	
	//print( "[PORTAL] Someone entered trigger!" )

	thread PortalTravelThink( trigger, player )
}

void function PortalTravelThink( entity trigger, entity player )
{
	//why endsignal so messed up
	//player.EndSignal( "OnDeath" )
	//player.EndSignal( "OnDestroy" )
	//trigger.EndSignal( "OnDestroy" )

	/* no need to try this, seriously
	array<string> originConver = split( trigger.kv.rendercolor, " " )
	float travelTime = float( trigger.kv.fadedist )
	vector goalOrigin = < float( originConver[0] ), float( originConver[1] ), float( originConver[2] ) >
	vector goalAngles = trigger.GetAngles()
	*/
	vector goalOrigin = portalGoalTable[ trigger ].goalPos
	vector goalAngles = portalGoalTable[ trigger ].goalAng
	float travelTime = portalGoalTable[ trigger ].travelTime
	string ownerUID = portalGoalTable[ trigger ].ownerUID
	bool canPortalOwner = portalGoalTable[ trigger ].canPortalOwner
	array<vector> progressPoses = portalGoalTable[ trigger ].savedVecs.progPoses
	array<vector> progressAngs = portalGoalTable[ trigger ].savedVecs.progAngs
	
	int totalSegments = progressPoses.len()
	float timePerSigment = PORTAL_TICKRATE + 0.05 // needs defensive fix
	float totalTime = travelTime
	float phaseTimeMulti = 1.1
	if( shouldDoWarpEffect && totalTime >= PORTAL_TRAVEL_LENGTH_MAX )
		phaseTimeMulti = 1.5

	/* //shouldn't be at the bottom of the function, or it will be pretty messed up
	OnThreadEnd(
		function() : ( player, mover )
		{
			if( IsValid( player ) )
			{
				CancelPhaseShift( player )
				player.SetVelocity( < 0,0,0 > )
				player.ClearParent()
				player.TouchGround()
			}
			if( IsValid( mover ) )
				mover.Destroy()
		}
	)
	*/

	if( player.IsPhaseShifted() )
	{
		return
	}
	if( player.GetUID() == ownerUID && !canPortalOwner )
	{
		portalGoalTable[ trigger ].canPortalOwner = true
		//print( "[PORTAL] Set owner able to use portal!" )
		return
	}
	if( inPortalCooldownPlayers.contains( player.GetUID() ) )
	{
		//print( "[PORTAL] Someone is in cooldown so cannot portal!" )
		return
	}
	if( player.GetUID() in playerPlacingPortal )
	{
		if( playerPlacingPortal[ player.GetUID() ] )
		{
			return
		}
	}
	if( !inPortalCooldownPlayers.contains( player.GetUID() ) )
	{
		thread PortalCooldownThink( player, totalTime * phaseTimeMulti )
		//print( "[PORTAL] Set someone in portal cooldown!" )
	}
	entity mover = CreateOwnedScriptMover (player)
	player.SetParent( mover )
	player.HolsterWeapon()
	PhaseShift( player, 0, totalTime * phaseTimeMulti ) // phase player, defensive fix
	if( shouldDoWarpEffect )
	{
		// phase all ticks
		if( IsValid( trigger ) )
		{
			if( trigger.GetTeam() == TEAM_MILITIA ) // endTrig confrimation, reversed array
			{
				// rotate is messed up
				//for( int i = totalSegments - 1, j = 0; i >= 0 && j <= totalSegments - 1; i--, j++ )
				for( int i = totalSegments - 1; i >= 0; i-- )
				{
					wait timePerSigment
					mover.NonPhysicsMoveTo( progressPoses[i] , timePerSigment, 0, 0 )
					// rotate is messed up
					//mover.NonPhysicsRotateTo( progressAngs[j], timePerSigment, 0, 0 )
					if( !IsAlive( player ) )
						break
				}
			}
			else if( trigger.GetTeam() == TEAM_IMC ) // startTrig confrimation, reversed array
			{
				for( int i = 0; i <= totalSegments - 1; i++ )
				{
					wait timePerSigment
					mover.NonPhysicsMoveTo( progressPoses[i] , timePerSigment, 0, 0 )
					//mover.NonPhysicsRotateTo( progressAngs[i], timePerSigment, 0, 0 )
					if( !IsAlive( player ) )
						break
				}
			}
		}
		wait totalTime * ( phaseTimeMulti - 1 )
	}
	else
	{
		mover.NonPhysicsMoveTo( goalOrigin , totalTime ,0, 0 )
		wait totalTime * phaseTimeMulti
	}
	if( IsValid( player ) )
	{
		player.SetVelocity( < 0,0,0 > )
		player.ClearParent()
		player.DeployWeapon()
		player.TouchGround() // able to double jump after leaving
		//whatever we get from segment teleports, just set player to the right origin
		player.SetOrigin( goalOrigin )
		//player.SetAngles( goalAngles )
		if( PlayerPosInSolid( player, player.GetOrigin() ) ) // re-exam
		{
			vector TargetPos = FindNearestSafePos( player, player.GetOrigin(), 1 )
			player.SetOrigin( TargetPos )
		}
	}
	mover.Destroy()
}

void function PortalCooldownThink( entity player, float travelTime )
{
	if( !IsValid( player ) )
		return
	string playerUID = player.GetUID()
	inPortalCooldownPlayers.append( playerUID )
	wait travelTime * 1.1 + PORTAL_DEPLOY_TIME
	inPortalCooldownPlayers.fastremovebyvalue( playerUID )
}

void function DelayedRechargeWeapon( entity weapon )
{
	wait PORTAL_DEPLOY_TIME
	if( IsValid( weapon ) )
		weapon.SetWeaponPrimaryClipCount( weapon.GetWeaponPrimaryClipCountMax() )
}

void function DelayedDiscardAmmo( entity weapon )
{
	wait PORTAL_DEPLOY_TIME
	if( IsValid( weapon ) )
		weapon.SetWeaponPrimaryClipCount( 0 )
}

void function DelayedClearTable( string playerUID )
{
	wait PORTAL_DEPLOY_TIME
	playerPlacingPortal[ playerUID ] <- false
}
#endif